# class Crystal::Macros::Union

- Crystal::Macros::Union
- Crystal::Macros::ASTNode

##
Overview

A type union, like `(Int32 | String)`.

##
Defined in:

compiler/crystal/macros.cr

##
Instance Method Summary

- #resolve : ASTNode

  Resolves this union to a `TypeNode`.

- #resolve? : ASTNode | NilLiteral

  Resolves this union to a `TypeNode`.

- #types : ArrayLiteral(ASTNode)

  Returns the types of this union.

### Instance methods inherited from class `Crystal::Macros::ASTNode`

!=(other : ASTNode) : BoolLiteral !=, ==(other : ASTNode) : BoolLiteral ==, class_name : StringLiteral class_name, column_number : StringLiteral | NilLiteral column_number, doc : StringLiteral doc, doc_comment : MacroId doc_comment, end_column_number : StringLiteral | NilLiteral end_column_number, end_line_number : StringLiteral | NilLiteral end_line_number, filename : StringLiteral | NilLiteral filename, id : MacroId id, is_a?(type : TypeNode) : BoolLiteral is_a?, line_number : StringLiteral | NilLiteral line_number, nil? : BoolLiteral nil?, raise(message) : NoReturn raise, stringify : StringLiteral stringify, symbolize : SymbolLiteral symbolize, warning(message : StringLiteral) : NilLiteral warning

##
Instance Method Detail

def resolve : ASTNode #

Resolves this union to a `TypeNode`. Gives a compile-time error if any type inside the union can't be resolved.

def resolve? : ASTNode | NilLiteral #

Resolves this union to a `TypeNode`. Returns a `NilLiteral` if any type inside the union can't be resolved.

def types : ArrayLiteral(ASTNode) #

Returns the types of this union.